## s390-tools 2.23.0

=== ziomon/Makefile ===
include ../common.mak

ALL_CPPFLAGS += -DNDEBUG
ALL_CFLAGS   += -Wundef -Wstrict-prototypes -Wno-trigraphs -Wno-address-of-packed-member
ALL_CXXFLAGS += -Wundef -Wno-trigraphs -Wno-address-of-packed-member

TARGETS = ziomon_util ziomon_mgr ziomon_zfcpdd ziorep_utilization ziorep_traffic
all: $(TARGETS)

ziomon_mgr_main.o: ziomon_mgr.c
	$(CC) -DWITH_MAIN $(ALL_CFLAGS) $(ALL_CPPFLAGS) -c $< -o $@
ziomon_mgr: LDLIBS += -lm
ziomon_mgr: ziomon_dacc.o ziomon_util.o ziomon_mgr_main.o ziomon_tools.o \
	    ziomon_zfcpdd.o ziomon_msg_tools.o
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

ziomon_util_main.o: ziomon_util.c ziomon_util.h
	$(CC) -DWITH_MAIN $(ALL_CFLAGS) $(ALL_CPPFLAGS) -c $< -o $@
ziomon_util: LDLIBS += -lm
ziomon_util: ziomon_util_main.o ziomon_tools.o
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

ziomon_zfcpdd_main.o: ziomon_zfcpdd.c ziomon_zfcpdd.h
	$(CC) -DWITH_MAIN $(ALL_CFLAGS) $(ALL_CPPFLAGS) -c $< -o $@
ziomon_zfcpdd: LDLIBS += -lm -lrt -lpthread
ziomon_zfcpdd: ziomon_zfcpdd_main.o ziomon_tools.o
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

ziorep_traffic: ziorep_traffic.o ziorep_framer.o ziorep_frameset.o \
		ziorep_printers.o ziomon_dacc.o ziomon_util.o \
		ziomon_msg_tools.o ziomon_tools.o ziomon_zfcpdd.o \
		ziorep_cfgreader.o ziorep_collapser.o ziorep_utils.o \
		ziorep_filters.o
	$(LINKXX) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

ziorep_utilization: ziorep_utilization.o ziorep_framer.o ziorep_frameset.o \
		    ziorep_printers.o ziomon_dacc.o ziomon_util.o \
		    ziomon_msg_tools.o ziomon_tools.o ziomon_zfcpdd.o \
		    ziorep_cfgreader.o ziorep_collapser.o ziorep_utils.o \
		    ziorep_filters.o
	$(LINKXX) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

install: all
	$(SED) -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' \
		< ziomon > $(DESTDIR)$(USRSBINDIR)/ziomon;
	chown $(OWNER).$(GROUP) $(DESTDIR)$(USRSBINDIR)/ziomon;
	chmod 755 $(DESTDIR)$(USRSBINDIR)/ziomon;
	$(SED) -e \
		's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' \
		< ziomon_fcpconf > $(DESTDIR)$(USRSBINDIR)/ziomon_fcpconf;
	chown $(OWNER).$(GROUP) $(DESTDIR)$(USRSBINDIR)/ziomon_fcpconf;
	chmod 755 $(DESTDIR)$(USRSBINDIR)/ziomon_fcpconf;
	$(SED) -e \
		's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' \
		< ziorep_config > $(DESTDIR)$(USRSBINDIR)/ziorep_config;
	chown $(OWNER).$(GROUP) $(DESTDIR)$(USRSBINDIR)/ziorep_config;
	chmod 755 $(DESTDIR)$(USRSBINDIR)/ziorep_config;
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziomon.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziomon_fcpconf.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ziomon_util \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziomon_util.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ziomon_mgr \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziomon_mgr.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ziomon_zfcpdd \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziomon_zfcpdd.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziorep_config.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ziorep_utilization \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziorep_utilization.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ziorep_traffic \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 ziorep_traffic.8 \
		$(DESTDIR)$(MANDIR)/man8

uninstall:
	rm $(DESTDIR)$(USRSBINDIR)/ziomon
	rm $(DESTDIR)$(USRSBINDIR)/ziomon_util
	rm $(DESTDIR)$(USRSBINDIR)/ziomon_mgr
	rm $(DESTDIR)$(USRSBINDIR)/ziomon_zfcpdd
	rm $(DESTDIR)$(USRSBINDIR)/ziomon_fcpconf
	rm $(DESTDIR)$(USRSBINDIR)/ziorep_config
	rm $(DESTDIR)$(USRSBINDIR)/ziorep_utilization
	rm $(DESTDIR)$(USRSBINDIR)/ziorep_traffic
	rm $(DESTDIR)$(MANDIR)/man8/ziomon.8*
	rm $(DESTDIR)$(MANDIR)/man8/ziomon_util.8*
	rm $(DESTDIR)$(MANDIR)/man8/ziomon_mgr.8*
	rm $(DESTDIR)$(MANDIR)/man8/ziomon_zfcpdd.8*
	rm $(DESTDIR)$(MANDIR)/man8/ziomon_fcpconf.8*
	rm $(DESTDIR)$(MANDIR)/man8/ziorep_config.8*
	rm $(DESTDIR)$(MANDIR)/man8/ziorep_utilization.8*
	rm $(DESTDIR)$(MANDIR)/man8/ziorep_traffic.8*

clean:
	-rm -f *.o $(TARGETS)

=== debian/changelog ===
s390-tools (2.23.0-0ubuntu1.1) kinetic; urgency=medium

  * d/p/lp1996069-zipl-boot-add-secure-boot-trailer.patch
    Add secure boot trailer in zipl stage 3 to keep compatibility with
    upcoming IBM zSystems firmware updates. (LP: #1996069)
  * Add d/p/lp1996477-dbginfo.sh-ensure-type-commands-compatible-with-dash.patch
    and d/p/lp1996477-dbginfo.sh-ensure-compatibility-with-bin-dash.patch
    to achieve dbginfo.sh compatibility with /bin/dash shell. (LP: #1996477)

 -- Frank Heimes <frank.heimes@canonical.com>  Wed, 16 Nov 2022 16:48:54 +0100

s390-tools (2.23.0-0ubuntu1) kinetic; urgency=medium

  * New upstream release, that solves LP: #1986991, but also the following:
    LP: #1986670, LP: #1929033, LP: #1852736, LP: #1959972, LP: #1982346,
    LP: #1982368, LP: #1982384, LP: #1982760, LP: #1982838 and LP: #1959987
  * Remove the following patches since they are included with this
    new upstream release:
    - d/p/e8fca95-zdev-Fix-off-by-one-errors-in-cio_ignore-handling.patch
    - d/p/455ad95-zdump-Fix-dev-mem-reading.patch
    - d/p/ee2c6d4-zipl-Allow-optional-entries-that-are-left-out-when-f.patch
    - d/p/a9e13a2d-genprotimg-introduce-macro-for-the-control-flags-and.patch
    - d/p/0906293c-genprotimg-enable-pckmo-and-disable-pckmo-are-mutual.patch
    - d/p/5394cd36-genprotimg-add-PV-guest-dump-support.patch
    - d/p/78b0533-genprotimg-remove-DigiCert-root-CA-pinning.patch
    - d/p/673ff37-genprotimg-check_hostkeydoc-relax-default-issuer-che.patch
    - d/p/0d15a07-chreipl-fcp-mpath-bundle-a-pre-cooked-man-page.patch
    - d/p/2515832-util_arch-Add-IBM-z16-as-known-machine.patch
    - d/p/cce5f51-cpumf-lscpumf-Add-IBM-z16-extended-counter-set-def.patch
    - d/p/b16a6d4f-lszcrypt-add-CEX8S-support.patch
    - d/p/bcbb6fca-zcryptstats-add-CEX8-support.patch
    - d/p/4382901d-lszcrypt-show-AP-bus-msg-size-limit-capability.patch
    - d/p/27dce331-lszcrypt-add-support-for-checkstop-state.patch
    - d/p/a29b3c89-lszcrypt-new-options-to-show-only-accel-cca-or-ep11-.patch
    - d/p/a8b0d7ac-lszcrypt-new-options-to-filter-cards-queues-only.patch
    - d/p/46fd42af-lszcrypt-new-option-to-show-the-serial-numbers-of-CC.patch
    - d/p/3a13cb4-dbginfo.sh-unify-console-output.patch
    - d/p/2eea614-dbginfo.sh-unify-indents-prettify-code.patch
    - d/p/fcb503e-dbginfo.sh-sync-excludes-in-sysfs-data-collection.patch
    - d/p/abec41f-dbginfo.sh-alphabetic-order-of-log-and-config-files.patch
    - d/p/164d481-dbginfo.sh-check-existence-of-dump2tar-before-execut.patch
    - d/p/50a4740-dbginfo.sh-replace-which-by-builtin-command-type-for.patch
    - d/p/2ab27bd-dbginfo.sh-update-copyright-date.patch
    - d/p/a8579a0-dbginfo.sh-replace-indents-with-8char-tab.patch
    - d/p/81920f7-dbginfo.sh-re-group-commands-for-network.patch
    - d/p/a0d6edf-dbginfo.sh-re-group-commands-by-long-output.patch
    - d/p/812df79-dbginfo.sh-re-group-commands-by-topic.patch
    - d/p/2677a41-dbginfo.sh-re-group-commands-by-system-state.patch
    - d/p/be47b51-dbginfo.sh-re-group-commands-by-z-device.patch
    - d/p/02a0d12-dbginfo.sh-re-group-commands-by-block-scsi.patch
    - d/p/0981df6-cmsfs-fuse-fix-enabling-of-hard_remove-option.patch
    - d/p/9e62005-genprotimg-boot-disable-Warray-bounds-for-now.patch
  * Remove d/p0010-no-pie-is-not-a-valid-option-for-ld.patch since it's solved
    upstream with 5e46632, 71fe581, b39bdfb, 9f6150d and ae72178.
  * Remove d/p/0001-zkey-add-initramfs-hook.patch since it's solved upstream
    with 3669fd4.
  * Remove d/p/0001-zkey-on-Ubuntu-use-default-benchmarked-Argon2i-with-.patch
    since it's solved upstream with 51b9504.
  * Remove d/p/0001-dumpconf-Don-t-run-the-service-in-LXC.patch since it's
    solved upstream with b4648ec.
  * Remove d/p/0001-ziomon-Use-exit-code-0-for-version-and-help.patch since
    it's solved upstream with 6919921.
  * Remove d/p/adjust-runlevels-in-dumpconf-initd-script.patch since it's
    solved upstream with 508253c, 13fef6d, a177ae2 and b01ef78.
  * Add build dependency to liblockfile-dev for new ap-check/libap.
  * Remove 'etc/init.d/dumpconf' from debian/s390-tools.install
    since it is no longer included in upstream anymore,
    but add lib/systemd/system/dumpconf.service instead.
  * Updated /usr/share/man/man1/zfcpdbf.1 to /usr/share/man/man8/zfcpdbf.8
    to reflect upstream changes.
  * Explicitly add pvattest-info script to debian/s390-tools.install.
  * Add new ap_tools script 'ap-check' to debian/s390-tools.install
    and add mdevctl as 'Suggests' to debian/control.
  * Add new files usr/share/man/man8/zipl.8, etc/ziplenv and
    usr/share/man/man8/zipl-editenv.8 to debian/s390-tools.install.
  * Remove README.md for genprotimg from debian/s390-tools.docs,
    since it's already included in debian/s390-tools.install.
  * Add readme files for pvattest, hsavmcore/initramfs, iucvterm/ts-shell
    and zfcpdump to debian/s390-tools.install and add '#!/usr/bin/dh-exec'
    to the top of debian/s390-tools.install and made it executable,
    and add dh-exec to Build-Depends in debian/control,
    to be able to rename the readme files to a common scheme.
  * Add AUTHORS.md and LICENSE files to debian/s390-tools.docs.
  * Fix 'binary-in-etc' lintian issue and move the binary 'ap-check' to
    /usr/lib/s390-tools/ in debian/rules and introduce a wrapper script
    in '/etc/mdevctl.d/scripts.d/callouts/ap-check' with the help of
    d/p/lp1986991-fix-binary-in-etc.patch.

 -- Frank Heimes <frank.heimes@canonical.com>  Wed, 17 Aug 2022 10:55:47 +0200

s390-tools (2.20.0-0ubuntu5) kinetic; urgency=medium
  
  * d/p/9e62005-genprotimg-boot-disable-Warray-bounds-for-now.patch:
    Fix FTBFS with GCC-12 using upstream commit 9e62005 (LP: #1986670)

 -- Lukas Märdian <slyon@ubuntu.com>  Wed, 17 Aug 2022 12:13:49 +0200

s390-tools (2.20.0-0ubuntu4) kinetic; urgency=medium

  * Fix chreipl-fcp-mpath (LP: #1971993)
    - Move chreipl-fcp-mpath* from /lib/udev/rules.d to /lib/udev.
    - d/control:


=== debian/control ===
Source: s390-tools
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>
Build-Depends: debhelper-compat (= 13), libz-dev, quilt, gcc-multilib, libfuse3-dev, libncurses-dev, libpfm4-dev, libssl-dev, libcurl4-openssl-dev, libcryptsetup-dev, libjson-c-dev, libsnmp-dev, libglib2.0-dev, libxml2-dev, bsdextrautils, liblockfile-dev, dh-exec
Standards-Version: 3.9.7
Homepage: https://github.com/ibm-s390-linux/s390-tools

Package: s390-tools
Architecture: s390 s390x
Priority: important
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, ${signing:Depends}, gawk, udev
Recommends: sg3-utils
Suggests: s390-tools-cpuplugd, s390-tools-osasnmpd, s390-tools-statd, s390-tools-chreipl-fcp-mpath, multipath-tools, lsscsi, rsync, blktrace, mdevctl
Description: fundamental utilities for Linux on z Systems
 The package contains:
  * dasdfmt, which is used to low-level format ECKD-DASDs with either
    the classic disk layout or the new zSeries compatible disk layout.
  * dasdview, which is used to display DASD and VTOC information or to
    dump the contents of a DASD to the console.
  * fdasd, which is used to create or modify partitions on ECKD-DASDs
    formatted with the zSeries compatible disk layout.
  * zipl, which is used to make either dasds or tapes bootable for
    system IPL or system dump.
  * zgetdump, which is used to retrieve system dumps from either tapes
    or dasds.
  * hsavmcore, which is used to make the dump process with kdump more
    efficient.
  * lshwc, which is used to extract and list complete counter sets

Package: s390-tools-cpuplugd
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: cpuplugd utility for Linux on z Systems
 The package contains cpuplugd hotplug daemon from the s390-tools
 collection of utilities.

Package: s390-tools-statd
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: s390-tools (<<1.34.0-0ubuntu7~)
Replaces: s390-tools (<<1.34.0-0ubuntu7~)
Description: mon_statd monitoring daemons for Linux on z Systems
 The package contains mon_procd and mon_fsstatd z/VM monitoring
 daemons for Linux on z Systems from the s390-tools collection of
 utilities. These tools are also known as mon_statd.

Package: s390-tools-osasnmpd
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}, udev
Description: osasnmpd utility for Linux on z Systems
 The package contains osasnmpd monitoring daemon from the s390-tools
 collection of utilities.

Package: s390-tools-zkey
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: zkey utilities for Linux on z Systems
 The package contains zkey and zkey-cryptsetup from the s390-tools
 collection of utilities.

Package: libekmfweb1
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: integration with IBM Enterprise Key Management Foundation
 This package contains library to integrate with IBM Enterprise Key
 Management Foundation. It is used by zkey plugin for pervasive
 encryption support.
 .
 This package contains the runtime library.

Package: libekmfweb-dev
Architecture: s390 s390x
Depends: ${misc:Depends}
Description: integration with IBM Enterprise Key Management Foundation (development)
 This package contains library to integrate with IBM Enterprise Key
 Management Foundation. It is used by zkey plugin for pervasive
 encryption support.
 .
 This package contains the development library and headers.

Package: libkmipclient1
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: KMIP client library
 A shared library that provides an KMIP client to communicate with an KMIP
 server. KMIP stands for Key Management Interoperability Protocol, and is an
 extensible communication protocol that defines message formats for the
 manipulation of cryptographic keys on a key management server.
 .
 This package contains the runtime library.

Package: libkmipclient-dev
Architecture: s390 s390x
Depends: ${misc:Depends}
Description: KMIP client library (development)
 A shared library that provides an KMIP client to communicate with an KMIP
 server. KMIP stands for Key Management Interoperability Protocol, and is an
 extensible communication protocol that defines message formats for the
 manipulation of cryptographic keys on a key management server.
 .
 This package contains the development library and headers

Package: s390-tools-chreipl-fcp-mpath
Architecture: s390 s390x
Depends: ${misc:Depends}, multipath-tools, multipath-tools-boot, udev
Description: chreipl-fcp-mpath utility for Linux on z Systems
 The package contains chreipl-fcp-mpath toolset from the s390-tools collection
 of utilities, that uses multipath information to change the configured FCP
 re-IPL path on detecting issues with the current path.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND = -D_GNU_SOURCE
export DEB_LDFLAGS_MAINT_APPEND=-rdynamic
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

options= V=1 HAVE_SNMP=1 SYSTEMDSYSTEMUNITDIR=/lib/systemd/system ZDEV_ALWAYS_UPDATE_INITRD=1 ZKEYKMSPLUGINDIR=/usr/libexec/zkey USRLIB64DIR=/usr/lib/s390x-linux-gnu

# Enable signing in Launchpad Only for now
SIGN_SIPL=
ifneq (,$(wildcard /CurrentlyBuilding))
SIGN_SIPL=yes
endif
SIGN_SIPL=yes

%:
	dh $@

override_dh_install:
	# no dracut
	rm -f debian/tmp/lib/s390-tools/zdev-root-update
	chmod -x debian/tmp/etc/*/*.conf debian/tmp/lib/s390-tools/zfcpdump/zfcpdump-initrd
	dh_install -ps390-tools-cpuplugd
	dh_install -ps390-tools-statd
	dh_install -ps390-tools-osasnmpd
	dh_install -ps390-tools-zkey
	dh_install -ps390-tools-chreipl-fcp-mpath
	dh_install $(if $(SIGN_SIPL),-Xstage3.bin) -Xcpuplugd -Xosasnmpd -Xprocd -Xfsstatd -X60-readahead.rules -Xzkey -Xchreipl-fcp-mpath
	$(if $(SIGN_SIPL),echo 'signing:Depends=s390-tools-signed (= $(DEB_VERSION))') >> debian/s390-tools.substvars
	find . -iname "ap-check.sh"

override_dh_fixperms:
	dh_fixperms
	chmod 644 debian/s390-tools-zkey/usr/libexec/zkey/zkey-ekmfweb.so
	chmod 644 debian/s390-tools-zkey/usr/libexec/zkey/zkey-kmip.so

override_dh_auto_clean:
	rm -f zipl/boot/.*.d
	dh_auto_clean -- $(options)

override_dh_auto_build:
	dh_auto_build -- $(options)

override_dh_auto_install:
	HAVE_INITRAMFS=1 HAVE_DRACUT=1 dh_auto_install -- $(options)
	mkdir -p ./debian/tmp/usr/lib/s390-tools/ && mv ./debian/tmp/etc/mdevctl.d/scripts.d/callouts/ap-check ./debian/tmp/usr/lib/s390-tools/

signing=debian/s390-tools-$(DEB_VERSION)-signing/
signingv=$(signing)/$(DEB_VERSION)
signing_tar=$(DEB_SOURCE)_$(DEB_VERSION)_$(DEB_HOST_ARCH).tar.gz
override_dh_builddeb:
	dh_builddeb
	mkdir -p $(signingv)/control
	echo 'tarball' >$(signingv)/control/options
	cp debian/tmp/lib/s390-tools/stage3.bin $(signingv)/stage3.bin.sipl
	tar -C $(signing) -czvf $(CURDIR)/../$(signing_tar) .
	dpkg-distaddfile $(signing_tar) raw-signing -
override_dh_clean:
	dh_clean
	rm -rf $(signing)

## s390-tools 2.26.0

=== Makefile ===
ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)

# Include common definitions
include common.mak

#
# BASELIBS: Libraries that have no dependency to other libraries in s390-tools
# LIBS: Libraries that can have a dependency to base libraries
# TOOLS: Tools that can have a dependency to base libraries or libraries
#
BASELIB_DIRS = libutil libseckey
LIB_DIRS = libvtoc libzds libdasd libccw libvmcp libekmfweb \
	   libkmipclient libcpumf libap libpv
TOOL_DIRS = zipl zdump fdasd dasdfmt dasdview tunedasd \
	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
	   vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc zpcictl \
	   genprotimg lsstp hsci hsavmcore chreipl-fcp-mpath ap_tools pvattest

SUB_DIRS = $(BASELIB_DIRS) $(LIB_DIRS) $(TOOL_DIRS)

all: $(TOOL_DIRS)
clean: $(TOOL_DIRS)
install: $(TOOL_DIRS)

#
# For simple "make" we explicitly set the MAKECMDGOALS to "all".
#
ifeq ($(MAKECMDGOALS),)
MAKECMDGOALS = all
endif

#
# We have to build the base libraries before the other libraries are built,
# and then build the other libraries before the tools are built. Otherwise the
# other libraries and tools would trigger parallel "make -C" builds for the
# base libraries and the other libraries in case of "make -j".
#
# MAKECMDGOALS contains the list of goals, e.g. "clean all". We use
# "foreach" to generate a ";" separated list of "make -C <target>".
# For example the the expansion for "make clean all" is:
#
# $(MAKE) -C $@ [..] clean ;  $(MAKE) -C $@ [...] all ;
#
# This ensures that the commandline targets are serialized and also "make -j"
# works as expected, e.g. "make clean all -j 20".
#

$(TOOL_DIRS): $(LIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
.PHONY: $(TOOL_DIRS)

$(LIB_DIRS): $(BASELIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
.PHONY: $(LIB_DIRS)

$(BASELIB_DIRS):
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
.PHONY: $(BASELIB_DIRS)

=== hmcdrvfs/Makefile ===
#!/usr/bin/make -f

include ../common.mak

ifeq (${HAVE_FUSE},0)

all:
	$(SKIP) HAVE_FUSE=0

install:
	$(SKIP) HAVE_FUSE=0

else

check_dep:
	$(call check_dep, \
		"hmcdrvfs", \
		"fuse.h", \
		"fuse3-devel or libfuse3-dev", \
		"HAVE_FUSE=0")

ifneq ($(shell sh -c 'command -v pkg-config'),)
FUSE_CFLAGS = $(shell pkg-config --silence-errors --cflags fuse3)
FUSE_LDLIBS = $(shell pkg-config --silence-errors --libs fuse3)
else
FUSE_CFLAGS = -D_FILE_OFFSET_BITS=64 -I/usr/include/fuse3
FUSE_LDLIBS = -lfuse3
endif
ALL_CFLAGS += -DFUSE_USE_VERSION=30 -D_LARGEFILE_SOURCE $(FUSE_CFLAGS)
LDLIBS += $(FUSE_LDLIBS) -lpthread -lrt -ldl -lm

OBJECTS = hmcdrvfs.o

libs = $(rootdir)/libutil/libutil.a

all: check_dep hmcdrvfs

$(OBJECTS): Makefile

hmcdrvfs: $(OBJECTS) $(libs)

install: all install-scripts
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 hmcdrvfs \
		$(DESTDIR)$(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 hmcdrvfs.1 \
		$(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 lshmc.8 \
		$(DESTDIR)$(MANDIR)/man8

install-scripts: lshmc
	@for i in $^; do \
		cat $$i | \
		sed -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' \
		>$(DESTDIR)$(USRSBINDIR)/$$i; \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(USRSBINDIR)/$$i; \
		chmod 755 $(DESTDIR)$(USRSBINDIR)/$$i; \
	done

endif

clean:
	rm -f hmcdrvfs *.o

.PHONY: all install install-scripts clean check_dep

=== zconf/Makefile ===
#==============================================================================
# Makefile for zSeries configuration utilities.
#==============================================================================
include ../common.mak

SCRIPTS	= lsdasd lstape chccwdev lszfcp cio_ignore znetconf dasdstat
USRSBIN_SCRIPTS = lsluns
MANPAGES= lsdasd.8 lstape.8 chccwdev.8 lszfcp.8 lsluns.8 \
	  cio_ignore.8 znetconf.8 dasdstat.8

SUB_DIRS = zcrypt scm chp css qeth

all: $(SUB_DIRS)

clean: $(SUB_DIRS)

install:	install-scripts install-manpages install-usrsbin-scripts $(SUB_DIRS)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 lsznet.raw \
		$(DESTDIR)$(TOOLS_LIBDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 znetcontrolunits \
		$(DESTDIR)$(TOOLS_LIBDIR)

install-scripts:	$(SCRIPTS)
	@for i in $^; do \
		cat $$i | \
		sed -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' \
		>$(DESTDIR)$(BINDIR)/$$i; \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(BINDIR)/$$i; \
		chmod 755 $(DESTDIR)$(BINDIR)/$$i; \
	done

install-usrsbin-scripts:	$(USRSBIN_SCRIPTS)
	@for i in $^; do \
		cat $$i | \
		sed -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' \
		>$(DESTDIR)$(USRSBINDIR)/$$i; \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(USRSBINDIR)/$$i; \
		chmod 755 $(DESTDIR)$(USRSBINDIR)/$$i; \
	done

install-manpages:	$(MANPAGES)
	@if [ ! -d $(DESTDIR)$(MANDIR) ]; then \
		mkdir -p $(DESTDIR)$(MANDIR)/man8; \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(MANDIR); \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(MANDIR)/man8; \
		chmod 755 $(DESTDIR)$(MANDIR); \
		chmod 755 $(DESTDIR)$(MANDIR)/man8; \
	fi; \
	for i in $^; do \
		install -o $(OWNER) -g $(GROUP) -m 644 $$i $(DESTDIR)$(MANDIR)/man8; \
	done

#
# For simple "make" we explicitly set the MAKECMDGOALS to "all".
#
ifeq ($(MAKECMDGOALS),)
MAKECMDGOALS = all
endif

$(SUB_DIRS):
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
.PHONY: $(SUB_DIRS)

.PHONY: all install clean install-scripts install-manpages install-usrsbin-scripts

=== zdump/Makefile ===
include ../common.mak

ALL_CFLAGS += -Wno-address-of-packed-member

#
# HAVE_FUSE: Allow to build zgetdump without mount support
#
ifeq (${HAVE_FUSE},0)

.check_dep_fuse:
	touch $@
else

.check_dep_fuse:
	$(call check_dep, \
		"zgetdump mount support", \
		"fuse.h", \
		"fuse3-devel or libfuse3-dev", \
		"HAVE_FUSE=0", \
		"-DFUSE_USE_VERSION=30")
	touch $@
endif

.detect_openssl.dep.c:
	echo "#include <openssl/evp.h>" > $@
	echo "#if OPENSSL_VERSION_NUMBER < 0x10100000L" >> $@
	echo "  #error At least OpenSSL version 1.1.0 is required" >> $@
	echo "#endif" >> $@
	echo "static void __attribute__((unused)) test(void) {" >> $@
	echo "    EVP_MD_CTX *ctx = EVP_MD_CTX_new();" >> $@
	echo "    EVP_MD_CTX_free(ctx);" >> $@
	echo "}" >> $@

.check_dep_zgetdump: .detect_openssl.dep.c .check_dep_fuse
	$(call check_dep, \
		"zgetdump", \
		"zlib.h", \
		"zlib-devel or libz-dev", \
		"HAVE_ZLIB=0")
	$(call check_dep, \
		"zgetdump", \
		"glib.h", \
		"glib2-devel / libglib2.0-dev", \
		"HAVE_GLIB2=0")
	$(call check_dep, \
		"zgetdump", \
		$<, \
		"openssl-devel / libssl-dev version >= 1.1.0", \
		"HAVE_OPENSSL=0", \
		"-I.")
	touch $@

#
# Allow skip of zgetdump build, when no zlib-devel, openssl-devel, glib2-devel is available
#
BUILD_TARGETS :=skip-zgetdump
INSTALL_TARGETS := skip-zgetdump
ifneq (${HAVE_ZLIB},0)
ifneq (${HAVE_OPENSSL},0)
ifneq (${HAVE_GLIB2},0)
BUILD_TARGETS := zgetdump
INSTALL_TARGETS := install-zgetdump
endif
endif
endif

OBJECTS = zgetdump.o opts.o zg.o zg_error.o zg_print.o \
	  dfi.o dfi_mem_chunk.o dfi_vmcoreinfo.o \
	  dfi_lkcd.o dfi_elf.o dfi_elf_common.o dfi_pv_elf.o \
	  dfi_s390.o dfi_s390_ext.o\
	  dfi_s390mv.o dfi_s390mv_ext.o \
	  dfi_s390tape.o dfi_kdump.o \
	  dfi_devmem.o dfo.o dfo_mem_chunk.o \
	  dfo_elf.o dfo_s390.o \
	  df_elf.o df_s390.o \
	  dt.o dt_s390sv.o dt_s390sv_ext.o \
	  dt_s390mv.o dt_s390mv_ext.o \
	  dt_scsi.o output.o \
	  ngdump.o dt_ngdump.o dfi_ngdump.o dfi_vmdump.o \
	  pv_utils.o

ifneq ($(shell sh -c 'command -v pkg-config'),)
GLIB2_CFLAGS := $(shell pkg-config --silence-errors --cflags glib-2.0)
GLIB2_LIBS := $(shell pkg-config --silence-errors --libs glib-2.0)
LIBCRYPTO_CFLAGS := $(shell pkg-config --silence-errors --cflags libcrypto)
LIBCRYPTO_LIBS := $(shell pkg-config --silence-errors --libs libcrypto)
else
GLIB2_CFLAGS := -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include
GLIB2_LIBS := -lglib-2.0
LIBCRYPTO_CFLAGS :=
LIBCRYPTO_LIBS := -lcrypto
endif

LIBPV = $(rootdir)/libpv/libpv.a
LIBPV_CFLAGS := -DOPENSSL_API_COMPAT=0x10100000L \
	$(GLIB2_CFLAGS) \
	$(LIBCRYPTO_CFLAGS) \
	$(NULL)
LIBPV_LIBS := $(GLIB2_LIBS) $(LIBCRYPTO_LIBS)

ifeq ("$(HAVE_FUSE)","0")
FUSE_CFLAGS = -DHAVE_FUSE=0 -D_FILE_OFFSET_BITS=64
FUSE_LDLIBS =
else ifneq ($(shell sh -c 'command -v pkg-config'),)
FUSE_CFLAGS = -DHAVE_FUSE=1 $(shell pkg-config --silence-errors --cflags fuse3)
FUSE_LDLIBS = $(shell pkg-config --silence-errors --libs fuse3)
else
FUSE_CFLAGS = -DHAVE_FUSE=1 -D_FILE_OFFSET_BITS=64 -I/usr/include/fuse3
FUSE_LDLIBS = -lfuse3
endif
LDLIBS += -lz $(FUSE_LDLIBS) $(LIBPV_LIBS)
ALL_CFLAGS += $(FUSE_CFLAGS) $(LIBPV_CFLAGS)

ifneq ("$(HAVE_FUSE)","0")
OBJECTS += zfuse.o
endif

libs = $(rootdir)/libutil/libutil.a $(LIBPV)

all: $(BUILD_TARGETS)

$(OBJECTS): .check_dep_zgetdump

zgetdump: $(OBJECTS) $(libs)

skip-zgetdump:
	echo "  SKIP    zgetdump due to unresolved dependencies"

install-zgetdump: zgetdump
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man8 $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 755 zgetdump $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 644 zgetdump.8 $(DESTDIR)$(MANDIR)/man8

install: $(INSTALL_TARGETS)

clean:
	rm -f -- *.o *~ zgetdump core.* .detect_openssl.dep.c .check_dep_zgetdump .check_dep_fuse

.PHONY: all install clean skip-zgetdump install-zgetdump

=== genprotimg/boot/Makefile ===
# Common definitions
include ../../common.mak

ZIPL_DIR := $(rootdir)/zipl
ZIPL_BOOT_DIR := $(ZIPL_DIR)/boot

INCLUDE_PATHS := $(ZIPL_BOOT_DIR) $(ZIPL_DIR)/include $(rootdir)/include
INCLUDE_PARMS := $(addprefix -I,$(INCLUDE_PATHS))

ALL_CFLAGS := $(NO_PIE_CFLAGS) -Os -g \
	$(INCLUDE_PARMS) \
	-DENABLE_SCLP_ASCII=1 \
	-DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE) \
	-fno-builtin -ffreestanding -fno-asynchronous-unwind-tables \
	-fno-delete-null-pointer-checks -fno-stack-protector \
	-fexec-charset=IBM1047 -m64 -mpacked-stack \
	-mstack-size=4096 -mstack-guard=128 -msoft-float \
	-Wall -Wformat-security -Wextra -Werror \
	-Wno-array-bounds

FILES := stage3a.bin stage3b.bin stage3b_reloc.bin

ZIPL_SRCS_C := libc.c ebcdic.c ebcdic_conv.c sclp.c
ZIPL_SRCS_ASM := entry.S

ZIPL_OBJS_C := $(ZIPL_SRCS_C:%.c=%.o)
ZIPL_OBJS_ASM := $(ZIPL_SRCS_ASM:%.S=%.o)
ZIPL_OBJS := $(ZIPL_OBJS_C) $(ZIPL_OBJS_ASM)


all: $(FILES)

# Prevent make from using some default rules...
%:	%.S

%.o:	%.S Makefile
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

%.o:	%.c Makefile
	$(CC) $(ALL_CFLAGS) -c -o $@ $<


# Dependencies for the .lds generation
sources_lds_S = $(wildcard *.lds.S)
dependencies_lds_S = $(sources_lds_S:%.lds.S=.%.lds.d)
# Include all ".lds.d" dependency files for all make targets except for "clean"
ifneq ($(MAKECMDGOALS),clean)
-include $(dependencies_lds_S)
endif

%.lds:	%.lds.S Makefile
	$(CPP) -Wp,-MD,.$@.d,-MT,$@ $(INCLUDE_PARMS) -P -C -o $@ $<

# Special rules for zipl object files
$(ZIPL_OBJS_C): %.o : $(ZIPL_BOOT_DIR)/%.c
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

$(ZIPL_OBJS_ASM): %.o : $(ZIPL_BOOT_DIR)/%.S
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

dependencies_zipl_c := $(ZIPL_SRCS_C:%.c=.%.o.d)

$(dependencies_zipl_c): .%.o.d : $(ZIPL_BOOT_DIR)/%.c
	$(CC_SILENT) -MM $(ALL_CPPFLAGS) $(ALL_CFLAGS) $< > $@

ifneq ($(MAKECMDGOALS),clean)
-include $(dependencies_zipl_c)
endif

stage3b_reloc.o: stage3b.bin

stage3a.elf: head.o stage3a_init.o $(ZIPL_OBJS)
stage3b.elf: head.o $(ZIPL_OBJS)

%.elf: %.lds %.o
	$(LINK) $(NO_PIE_LDFLAGS) $(NO_WARN_RWX_SEGMENTS_LDFLAGS) -Wl,-T,$< -Wl,--build-id=none -m64 -static -nostdlib $(filter %.o, $^) -o $@
	@chmod a-x $@

%.bin: %.elf
	$(OBJCOPY) -O binary $< $@
	@chmod a-x $@

clean:
	rm -f *.o *.elf *.bin *.map .*.d *.lds

.PHONY: all clean

=== zipl/boot/Makefile ===
# Common definitions
include ../../common.mak

INCLUDE_PATHS := $(rootdir)/zipl/include $(rootdir)/include
INCLUDE_PARMS := $(addprefix -I,$(INCLUDE_PATHS))

ALL_CFLAGS = $(NO_PIE_CFLAGS) -Os -g $(INCLUDE_PARMS) \
	  -DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE) \
	  -fno-builtin -ffreestanding -fno-asynchronous-unwind-tables \
	  -fno-delete-null-pointer-checks -fno-stack-protector \
	  -fexec-charset=IBM1047 -m64 -mpacked-stack \
	  -mstack-size=4096 -mstack-guard=128 -msoft-float \
	  -W -Wall -Wformat-security -fno-sanitize=all
ALL_LDFLAGS += -fno-sanitize=all

FILES	= fba0.bin fba1b.bin fba2.bin \
	  eckd0_ldl.bin eckd0_cdl.bin \
	  eckd1.bin eckd1b.bin eckd2.bin \
	  tape0.bin \
	  eckd2dump_sv.bin tape2dump.bin fba2dump.bin eckd2dump_mv.bin

all: .loaders tape0.bin stage3.bin

.loaders: $(FILES)
	touch .loaders

# Prevent make from using some default rules...
%:	%.S

%.o:	%.S
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

%.o:	%.c
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

# Dependencies for the .lds generation
sources_lds_S = $(wildcard *.lds.S)
dependencies_lds_S = $(sources_lds_S:%.lds.S=.%.lds.d)
# Include all ".lds.d" dependency files for all make targets except for "clean"
ifneq ($(MAKECMDGOALS),clean)
-include $(dependencies_lds_S)
endif

%.lds: %.lds.S
	$(CPP) -Wp,-MD,.$@.d,-MT,$@ $(INCLUDE_PARMS) -P -C -o $@ $<

fba0.exec eckd0_ldl.exec eckd0_cdl.exec tape0.exec: \
	stage0.lds

eckd1.exec: \
	stage1.lds

eckd1b.exec fba1b.exec: \
	stage1b.lds

eckd2dump_sv.exec: \
	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_sv.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
eckd2dump_mv.exec: \
	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_mv.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
fba2dump.exec: \
	head.o stage2dump.o cio.o fba2dump.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
tape2dump.exec: \
	head.o stage2dump.o cio.o tape2dump.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
eckd2.exec: head.o stage2.o cio.o eckd2.o libc.o ebcdic.o menu.o sclp.o \
	    kdump2.o kdump.o entry.o stage2.lds
fba2.exec: head.o stage2.o cio.o fba2.o libc.o ebcdic.o menu.o sclp.o \
	   kdump2.o kdump.o entry.o stage2.lds
stage3.exec: head.o stage3.o kdump3.o libc.o ebcdic.o ebcdic_conv.o sclp.o \
	     sclp_stage3.o kdump.o entry.o stage3.lds

%.exec:	%.o
	$(LINK) -Wl,-T,$(filter %.lds,$^) $(NO_PIE_LDFLAGS) $(NO_WARN_RWX_SEGMENTS_LDFLAGS) -Wl,--build-id=none -m64 -static -nostdlib $(filter %.o, $^) -o $@

%.bin:	%.exec
	$(OBJCOPY) -O binary $< $@


clean:
	rm -f -- *.o *.exec *.bin $(FILES) tape0.bin *.xxx *.yyy \
	      stage3.bin *.lds .*.lds.d .loaders

.PHONY: all clean

=== debian/changelog ===
s390-tools (2.26.0-0ubuntu1) lunar; urgency=medium

  * New upstream release, requested in LP: #2003284
    but also solves: LP: #1982339, LP: #2003281, LP: #2003286, LP: #2003393 and
    LP: #2003680
  * Update 'Standards-Version' field in d/control to latest version 4.6.1.0.

 -- Frank Heimes <frank.heimes@canonical.com>  Tue, 14 Feb 2023 15:00:53 +0100

s390-tools (2.25.0-0ubuntu1) lunar; urgency=medium

  * New upstream release, requested in LP: #2006451
  * Remove d/p/lp1986991-fix-binary-in-etc.patch and the corresponding lines
    in debian/rules and debian/s390-tools.install, since a fix for this is 
    now upstream included with commit 4b5937f
    "ap_tools/ap-check: use new mdevctl install location".

 -- Frank Heimes <frank.heimes@canonical.com>  Thu, 26 Jan 2023 12:22:05 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 XSBC-Original-Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
 Uploaders: Bastian Blank <waldi@debian.org>
 Build-Depends: debhelper-compat (= 13), libz-dev, quilt, gcc-multilib, libfuse3-dev, libncurses-dev, libpfm4-dev, libssl-dev, libcurl4-openssl-dev, libcryptsetup-dev, libjson-c-dev, libsnmp-dev, libglib2.0-dev, libxml2-dev, bsdextrautils, liblockfile-dev, dh-exec
-Standards-Version: 3.9.7
+Standards-Version: 4.6.1.0
 Homepage: https://github.com/ibm-s390-linux/s390-tools
 
 Package: s390-tools

## s390-tools 2.28.0

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,3 @@
-ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)
-
 # Include common definitions
 include common.mak
 
@@ -8,6 +6,7 @@
 # LIBS: Libraries that can have a dependency to base libraries
 # TOOLS: Tools that can have a dependency to base libraries or libraries
 #
+ifeq ($(HOST_ARCH),s390x)
 BASELIB_DIRS = libutil libseckey
 LIB_DIRS = libvtoc libzds libdasd libccw libvmcp libekmfweb \
 	   libkmipclient libcpumf libap libpv
@@ -17,6 +16,11 @@
 	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
 	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc zpcictl \
 	   genprotimg lsstp hsci hsavmcore chreipl-fcp-mpath ap_tools pvattest
+else
+BASELIB_DIRS =
+LIB_DIRS = libpv
+TOOL_DIRS = genprotimg pvattest
+endif
 
 SUB_DIRS = $(BASELIB_DIRS) $(LIB_DIRS) $(TOOL_DIRS)
 
@@ -49,15 +53,15 @@
 
 $(TOOL_DIRS): $(LIB_DIRS)
 	$(foreach goal,$(MAKECMDGOALS), \
-		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
+		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
 .PHONY: $(TOOL_DIRS)
 
 $(LIB_DIRS): $(BASELIB_DIRS)
 	$(foreach goal,$(MAKECMDGOALS), \
-		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
+		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
 .PHONY: $(LIB_DIRS)
 
 $(BASELIB_DIRS):
 	$(foreach goal,$(MAKECMDGOALS), \
-		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
+		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
 .PHONY: $(BASELIB_DIRS)

=== genprotimg/Makefile ===
# Common definitions
include ../common.mak

.DEFAULT_GOAL := all

PKGDATADIR := "$(DESTDIR)$(TOOLS_DATADIR)/genprotimg"
TESTS :=
SUBDIRS := boot src man
RECURSIVE_TARGETS := all-recursive install-recursive clean-recursive

all: all-recursive

install: all install-recursive
	$(INSTALL) -d -m 755 "$(PKGDATADIR)"
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 samples/check_hostkeydoc "$(PKGDATADIR)"

clean: clean-recursive

$(RECURSIVE_TARGETS):
	@target=`echo $@ |sed s/-recursive//`; \
		for d in $(SUBDIRS); do \
			$(MAKE) -C $$d $$target || exit 1; \
		done

.PHONY: all install clean $(RECURSIVE_TARGETS)

=== genprotimg/boot/Makefile ===
--- 
+++ 
@@ -1,8 +1,12 @@
 # Common definitions
 include ../../common.mak
 
+FILES := stage3a.bin stage3b.bin stage3b_reloc.bin
+
+ifeq ($(HOST_ARCH),s390x)
 ZIPL_DIR := $(rootdir)/zipl
 ZIPL_BOOT_DIR := $(ZIPL_DIR)/boot
+PKGDATADIR := $(DESTDIR)$(TOOLS_DATADIR)/genprotimg
 
 INCLUDE_PATHS := $(ZIPL_BOOT_DIR) $(ZIPL_DIR)/include $(rootdir)/include
 INCLUDE_PARMS := $(addprefix -I,$(INCLUDE_PATHS))
@@ -15,10 +19,8 @@
 	-fno-delete-null-pointer-checks -fno-stack-protector \
 	-fexec-charset=IBM1047 -m64 -mpacked-stack \
 	-mstack-size=4096 -mstack-guard=128 -msoft-float \
-	-Wall -Wformat-security -Wextra -Werror \
+	-Wall -Wformat-security -Wextra \
 	-Wno-array-bounds
-
-FILES := stage3a.bin stage3b.bin stage3b_reloc.bin
 
 ZIPL_SRCS_C := libc.c ebcdic.c ebcdic_conv.c sclp.c
 ZIPL_SRCS_ASM := entry.S
@@ -26,9 +28,6 @@
 ZIPL_OBJS_C := $(ZIPL_SRCS_C:%.c=%.o)
 ZIPL_OBJS_ASM := $(ZIPL_SRCS_ASM:%.S=%.o)
 ZIPL_OBJS := $(ZIPL_OBJS_C) $(ZIPL_OBJS_ASM)
-
-
-all: $(FILES)
 
 # Prevent make from using some default rules...
 %:	%.S
@@ -80,6 +79,26 @@
 	$(OBJCOPY) -O binary $< $@
 	@chmod a-x $@
 
+install: stage3a.bin stage3b_reloc.bin
+	$(INSTALL) -d -m 755 "$(PKGDATADIR)"
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 stage3a.bin "$(PKGDATADIR)"
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 stage3b_reloc.bin "$(PKGDATADIR)"
+
+else
+# Don't generate the dependency files (see `common.mak` for the
+# `-include $(dependencies_c)` statement).
+.PHONY: $(dependencies_c)
+
+$(FILES):
+	echo "  SKIP    $@ due to HOST_ARCH != s390x"
+
+install:
+	echo "  SKIP    Bootloader installation due to HOST_ARCH != s390x"
+endif
+
+.DEFAULT_GOAL := all
+all: $(FILES)
+
 clean:
 	rm -f *.o *.elf *.bin *.map .*.d *.lds

=== debian/changelog ===
s390-tools (2.28.0-0ubuntu2) mantic; urgency=medium

  * Extend s390-tools package to amd64, ppc64el and arm64. (LP: #2025578)
    - d/control: - Extend Architecture: in s390-tools with amd64 ppc64el arm64
                 - Add new package s390-tools-data as 'Architecture: all'.
                 - Extend Depends: in s390-tools with s390-tools-data.
                 - Limit Depends on gcc-multilib to s390x.
                 - Add 'XS-Build-Indep-Architecture: s390x' to ensure building
                   the 'Architecture: all' on s390x.
                 - Mark Depends, Suggests and Recommends for s390x only where
                   needed to avoid confusing messages on non-s390x installs.
                 - Add Replaces and Breaks s390-tools (<< 2.28.0-0ubuntu2)
                   to allow smooth upgrades, since stage3a.bin moved to -data.
    - d/rules: - Separate selected statements in d/rules in s390x
                 (and non-s390x).
               - Add '-Xstage3a.bin -Xstage3b_reloc.bin' to dh_install
                 to avoid having these files in two packages (s390-tools
                 and s390-tools-data).
               - Change SIGN_SIPL condition to enable signing in Launchpad
                 only, and on s390x only.
    - d/s390-tools.install: - Make this old d/s390-tools.install the new s390x
                              specific version (.install.s390x) (by using mv).
                            - Remove lines with "=>" that rename files, to
                              eliminate executable .install.s390x file and
                              remove '#!/usr/bin/dh-exec', since this doesn't
                              seem to work for arch specific install files.
                            - Create new d/s390-tools.install to become the
                              default version for non-s390x, and install only
                              files for pvattest and genprotimg.
    - d/s390-tools-data.install: Pick and install bootloader files (stage3a.bin
                                 and stage3b_reloc.bin) required by genprotimg.
    - d/s390-tools.postinst: Make this old d/s390-tools.postinst now s390x
                             specific (mv to d/s390-tools.postinst.s390x).
    - Add d/p/lp-2025578-Recursive-Makefiles-avoid-race-condition.patch
      to fix random build failures due to race condition in install target.

 -- Frank Heimes <frank.heimes@canonical.com>  Wed, 26 Jul 2023 16:56:00 +0200

s390-tools (2.28.0-0ubuntu1) mantic; urgency=medium

  * New upstream release, requested in LP: #2025781
    - Adds Secure Execution APQN binding and IBK association LP: #2003633
    - Adds Support for List-Directed dump from ECKD DASD LP: #2003397
    - Adds DASD autoquiesce support LP: #2025576
    - Add pkg-config to d/control, since it's required now (4bba105).
    - Remove d/p/bashism.patch, since it's incl. in upstream now (5522aae).
  * d/control: 'wrap-and-sort -s' run

 -- Frank Heimes <frank.heimes@canonical.com>  Tue, 25 Jul 2023 10:10:36 +0200

=== debian/control ===
--- 
+++ 
@@ -4,16 +4,51 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
 Uploaders: Bastian Blank <waldi@debian.org>
-Build-Depends: debhelper-compat (= 13), libz-dev, quilt, gcc-multilib, libfuse3-dev, libncurses-dev, libpfm4-dev, libssl-dev, libcurl4-openssl-dev, libcryptsetup-dev, libjson-c-dev, libsnmp-dev, libglib2.0-dev, libxml2-dev, bsdextrautils, liblockfile-dev, dh-exec
+Build-Depends:
+ bsdextrautils,
+ debhelper-compat (= 13),
+ dh-exec,
+ gcc-multilib [s390 s390x],
+ libcryptsetup-dev,
+ libcurl4-openssl-dev,
+ libfuse3-dev,
+ libglib2.0-dev,
+ libjson-c-dev,
+ liblockfile-dev,
+ libncurses-dev,
+ libpfm4-dev,
+ libsnmp-dev,
+ libssl-dev,
+ libxml2-dev,
+ libz-dev,
+ pkg-config,
+ quilt
 Standards-Version: 4.6.1.0
 Homepage: https://github.com/ibm-s390-linux/s390-tools
+XS-Build-Indep-Architecture: s390x
 
 Package: s390-tools
-Architecture: s390 s390x
+Architecture: s390 s390x amd64 ppc64el arm64
 Priority: important
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, ${signing:Depends}, gawk, udev
-Recommends: sg3-utils
-Suggests: s390-tools-cpuplugd, s390-tools-osasnmpd, s390-tools-statd, s390-tools-chreipl-fcp-mpath, multipath-tools, lsscsi, rsync, blktrace, mdevctl
+Depends:
+ gawk [s390 s390x],
+ s390-tools-data,
+ udev [s390 s390x],
+ ${misc:Depends},
+ ${perl:Depends},
+ ${shlibs:Depends},
+ ${signing:Depends}
+Recommends: sg3-utils [s390 s390x]
+Suggests:
+ blktrace [s390 s390x],
+ lsscsi [s390 s390x],
+ mdevctl [s390 s390x],
+ multipath-tools [s390 s390x],
+ rsync [s390 s390x],
+ s390-tools-chreipl-fcp-mpath [s390 s390x],
+ s390-tools-cpuplugd [s390 s390x],
+ s390-tools-osasnmpd [s390 s390x],
+ s390-tools-statd [s390 s390x]
 Description: fundamental utilities for Linux on z Systems
  The package contains:
   * dasdfmt, which is used to low-level format ECKD-DASDs with either
@@ -32,14 +67,14 @@
 
 Package: s390-tools-cpuplugd
 Architecture: s390 s390x
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: cpuplugd utility for Linux on z Systems
  The package contains cpuplugd hotplug daemon from the s390-tools
  collection of utilities.
 
 Package: s390-tools-statd
 Architecture: s390 s390x
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Breaks: s390-tools (<<1.34.0-0ubuntu7~)
 Replaces: s390-tools (<<1.34.0-0ubuntu7~)
 Description: mon_statd monitoring daemons for Linux on z Systems
@@ -49,21 +84,21 @@
 
 Package: s390-tools-osasnmpd
 Architecture: s390 s390x
-Depends: ${shlibs:Depends}, ${misc:Depends}, udev
+Depends: udev, ${misc:Depends}, ${shlibs:Depends}
 Description: osasnmpd utility for Linux on z Systems
  The package contains osasnmpd monitoring daemon from the s390-tools
  collection of utilities.
 
 Package: s390-tools-zkey
 Architecture: s390 s390x
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: zkey utilities for Linux on z Systems
  The package contains zkey and zkey-cryptsetup from the s390-tools
  collection of utilities.
 
 Package: libekmfweb1
 Architecture: s390 s390x
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: integration with IBM Enterprise Key Management Foundation
  This package contains library to integrate with IBM Enterprise Key
  Management Foundation. It is used by zkey plugin for pervasive
@@ -83,7 +118,7 @@
 
 Package: libkmipclient1
 Architecture: s390 s390x
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: KMIP client library
  A shared library that provides an KMIP client to communicate with an KMIP
  server. KMIP stands for Key Management Interoperability Protocol, and is an
@@ -105,8 +140,17 @@
 
 Package: s390-tools-chreipl-fcp-mpath
 Architecture: s390 s390x
-Depends: ${misc:Depends}, multipath-tools, multipath-tools-boot, udev
+Depends: multipath-tools, multipath-tools-boot, udev, ${misc:Depends}
 Description: chreipl-fcp-mpath utility for Linux on z Systems
  The package contains chreipl-fcp-mpath toolset from the s390-tools collection
  of utilities, that uses multipath information to change the configured FCP
  re-IPL path on detecting issues with the current path.
+
+Package: s390-tools-data
+Architecture: all
+Depends: ${misc:Depends}
+Replaces: s390-tools (<< 2.28.0-0ubuntu2)
+Breaks: s390-tools (<< 2.28.0-0ubuntu2)
+Description: fundamental utilities for Linux on z Systems (data files)
+ Host architecture independent files used by s390-tools utilities for
+ z Systems. Currently this package ships stage3a/b files for genprotimg.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND = -D_GNU_SOURCE
export DEB_LDFLAGS_MAINT_APPEND=-rdynamic
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

ifeq ($(DEB_HOST_ARCH),s390x)
	options= V=1 HAVE_SNMP=1 SYSTEMDSYSTEMUNITDIR=/lib/systemd/system ZDEV_ALWAYS_UPDATE_INITRD=1 ZKEYKMSPLUGINDIR=/usr/libexec/zkey USRLIB64DIR=/usr/lib/s390x-linux-gnu
endif

# Enable signing in Launchpad only, and on s390x only
SIGN_SIPL=
ifeq ($(DEB_HOST_ARCH),s390x)
	ifneq (,$(wildcard /CurrentlyBuilding))
		SIGN_SIPL=yes
	endif
endif

%:
	dh $@

override_dh_install:
ifeq ($(DEB_HOST_ARCH),s390x)
	# no dracut
	rm -f debian/tmp/lib/s390-tools/zdev-root-update
	chmod -x debian/tmp/etc/*/*.conf debian/tmp/lib/s390-tools/zfcpdump/zfcpdump-initrd
	dh_install -ps390-tools-cpuplugd
	dh_install -ps390-tools-statd
	dh_install -ps390-tools-osasnmpd
	dh_install -ps390-tools-zkey
	dh_install -ps390-tools-chreipl-fcp-mpath
	dh_install -ps390-tools-data
	dh_install $(if $(SIGN_SIPL),-Xstage3.bin) -Xcpuplugd -Xosasnmpd -Xprocd -Xfsstatd -X60-readahead.rules -Xzkey -Xchreipl-fcp-mpath -Xdata -Xstage3a.bin -Xstage3b_reloc.bin
	$(if $(SIGN_SIPL),echo 'signing:Depends=s390-tools-signed (= $(DEB_VERSION))') >> debian/s390-tools.substvars
else
	dh_install -Xstage3a.bin -Xstage3b_reloc.bin
endif

override_dh_fixperms:
	dh_fixperms
ifeq ($(DEB_HOST_ARCH),s390x)
	chmod 644 debian/s390-tools-zkey/usr/libexec/zkey/zkey-ekmfweb.so
	chmod 644 debian/s390-tools-zkey/usr/libexec/zkey/zkey-kmip.so
endif

override_dh_auto_clean:
	rm -f zipl/boot/.*.d
	dh_auto_clean -- $(options)

override_dh_auto_build:
	dh_auto_build -- $(options)

override_dh_auto_install:
	HAVE_INITRAMFS=1 HAVE_DRACUT=1 dh_auto_install -- $(options)

signing=debian/s390-tools-$(DEB_VERSION)-signing/
signingv=$(signing)/$(DEB_VERSION)
signing_tar=$(DEB_SOURCE)_$(DEB_VERSION)_$(DEB_HOST_ARCH).tar.gz
override_dh_builddeb:
	dh_builddeb
ifeq ($(DEB_HOST_ARCH),s390x)
	mkdir -p $(signingv)/control
	echo 'tarball' >$(signingv)/control/options
	cp debian/tmp/lib/s390-tools/stage3.bin $(signingv)/stage3.bin.sipl
	tar -C $(signing) -czvf $(CURDIR)/../$(signing_tar) .
	dpkg-distaddfile $(signing_tar) raw-signing -
endif
override_dh_clean:
	dh_clean
	rm -rf $(signing)
